码迷,mamicode.com
首页 > 编程语言 > 详细

HDU 2389 Rain on your Parade (二分图匹配(Hopcroft-Carp的算法模板))

时间:2015-05-17 00:52:31      阅读:185      评论:0      收藏:0      [点我收藏+]

标签:图论   算法   

Rain on your Parade

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 655350/165535 K (Java/Others)
Total Submission(s): 3033    Accepted Submission(s): 952


Problem Description
You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could be the perfect end of a beautiful day.
But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence they stand terrified when hearing the bad news.
You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.
Can you help your guests so that as many as possible find an umbrella before it starts to pour?

Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.
 

Input
The input starts with a line containing a single integer, the number of test cases.
Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units per minute (1 <= si <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated by a space.
The absolute value of all coordinates is less than 10000.
 

Output
For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test case with a blank line.
 

Sample Input
2 1 2 1 0 3 3 0 3 2 4 0 6 0 1 2 1 1 2 3 3 2 2 2 2 4 4
 

Sample Output
Scenario #1: 2 Scenario #2: 2
 

Source
题意:第一行案例数,每个案例第一行 代表还有多少单位时间开始下雨,然后是 N个访客,接下来N行是 每个访客的位置(一维坐标平面内)和他的移动速度,接下来M行 代表雨伞数目,接下来M行表示各个雨伞的位置,问在下雨前 最多有多少人能够拿到雨伞(两个人不能共用一把伞)。
解析:以在给定的时间内 人能到达伞的位置 建边,二分最大匹配,如果直接用经典匈牙利算法一定分超时的,可用Hopcroft-Karp算法(O(sqrt(n)*edgnum)). 546MS AC。
#include<stdio.h>
#include<string.h>
#include<queue>
#include<math.h>
using namespace std;
const int N = 3005;
const int INF=1<<28;

int head[N],to[N*N],next1[N*N],tot;  //存图
int dx[N],dy[N],dis;                 //左边部分距离,右边部分距离,记录右边部分没有被匹配过的点的最大距离
int machx[N],nx,machy[N];            //左边部分点匹配右边点,左边部分的点个数,右边部分点匹配左边的点
bool vist[N];

void addEdg(int u,int v){
    to[tot]=v; next1[tot]=head[u]; head[u]=tot++;
}
bool searchpath(){//找有没有增广路
    queue<int>q;
    dis=INF;
    memset(dx,-1,sizeof(dx));
    memset(dy,-1,sizeof(dy));

    for(int i=1; i<=nx; i++)
        if(machx[i]==-1)
        q.push(i),dx[i]=0;

    while(!q.empty()){
        int u=q.front(); q.pop();
        if(dx[u]>dis)
            break;
        for(int i=head[u]; i!=-1; i=next1[i]){
            int v=to[i];
            if(dy[v]==-1){
                dy[v]=dx[u]+1;
                if(machy[v]==-1)
                    dis=dy[v];
                else{
                    dx[machy[v]]=dy[v]+1;
                    q.push(machy[v]);
                }
            }
        }
    }
    return dis!=INF;
}
bool findroad(int u){
    for(int i=head[u]; i!=-1; i=next1[i]){
        int v=to[i];
        if(!vist[v]&&dy[v]==dx[u]+1){
            vist[v]=1;
            if(machy[v]!=-1&&dy[v]==dis)
                continue;
            if(machy[v]==-1||findroad(machy[v])){
                machy[v]=u; machx[u]=v;  return true;
            }
        }
    }
    return false;
}
int MaxMatch(){
    int ans=0;
    memset(machx,-1,sizeof(machx));
    memset(machy,-1,sizeof(machy));
    while( searchpath() ){
        memset(vist,0,sizeof(vist));
        for(int i=1; i<=nx; i++)
            if(machx[i]==-1)
            ans+=findroad(i);
    }
    return ans;
}
//-------------上面部分的代码为模板---------------------

struct node{
    int x,y;
    double dis;
}man[N],umb[N];

double countDis(int u,int v){
    return sqrt((man[u].x-umb[v].x)*(man[u].x-umb[v].x)*1.0+(man[u].y-umb[v].y)*(man[u].y-umb[v].y)*1.0);
}
int main(){
    int T,ny,tim,c=0;
    scanf("%d",&T);
    while(T--){
        scanf("%d%d",&tim,&nx);
        for(int i=1;i<=nx;i++){
            scanf("%d%d%lf",&man[i].x,&man[i].y,&man[i].dis);
            man[i].dis*=tim;
        }
        scanf("%d",&ny);
        for(int i=1;i<=ny;i++)
            scanf("%d%d",&umb[i].x,&umb[i].y);

//---------------------建图---------------------
        tot=0;
        memset(head,-1,sizeof(head));
        for(int u=1;u<=nx;u++)
            for(int v=1;v<=ny;v++)
            if(man[u].dis>=countDis(u,v))
                addEdg(u,v);
//----------------------------------------------
        int ans=MaxMatch();
        printf("Scenario #%d:\n%d\n\n",++c,ans);
    }
    return 0;
}


HDU 2389 Rain on your Parade (二分图匹配(Hopcroft-Carp的算法模板))

标签:图论   算法   

原文地址:http://blog.csdn.net/u010372095/article/details/45772801

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!